Changes from 3.4.4 to 3.4.5

*Kernel:
- Made sure all errors, warnings and notices in eZScript are sent to stderr.
- Fixed fetching collaboration list with offset.
  Merged from stable/3.3 rev. 10112.
- Made sure newly created packages have the package information set.
- Fixed a problem in redirection when the redirect url did not start with a
  slash.
  (Merged from trunk (3.5.1) rev. 10389)
- Added support for user parameters in layout/set/ URLs.
- Added pdf view mode to CachedViewModes.
- Modified: It is now possible to include additional PHP files for the
  simpletags operator.
- Added support for setting information collection email sender in templates
- Fixed problem with updateniceurls.php which would not create a forwarding
  url when it created a new nice url for a node.
  (Merged from stable/3.5 (3.5.0) rev. 10428)
- Fixed wrong check in initialize function for eZMedia and eZEnum datatypes,
  the variable $currentVersion must not use !== for value checking.
  (Merged from stable/3.5 (3.5.0) rev. 10437)
- Fixed wrong initialization of internal option array for eZRangeOption and
  eZOption datatype.
  (Merged from stable/3.5 (3.5.0) rev. 10437)
- Fixed wrong SQL generation in eZURL datatype when it does not have a url ID
  (data_int).
  (Merged from stable/3.5 (3.5.0) rev. 10437)
- Fixed create() method of eZRole, eZPolicy, eZPolicyLimitation and
  eZPolicyLimitationValue to use null for the 'id' attribute instead of false.
  Without this the auto-increment value would not be used for this attribute.
  (Merged from stable/3.5 (3.5.0) rev. 10450)
- Fixed bug #6156: Fatal error - Missing include in ezrole.php
  (Merged from stable/3.4 (3.4.5) rev. 10851)
- Fixed problem with anonymous user having access to other peoples drafts in
  content/draft.
  (Merged from release/3.3-7 rev. 10927)

eZPersistentObject:
- Fixed: $fieldFilters parameter to storeObject() were not used to filter.
  (Merged from release/3.3-7 rev. 10897)
- Fixed: attributes() functions can return duplicate attributes in some cases.
  (Merged from release/3.3-7 rev. 10899)

Webdav:
- Made sure extensions are enabled in webdav handler.
  (Merged from release/3.3-7 rev. 10887)
- Made sure site.ini and template.ini reloads its cache after extension
  enabling.

*Datatypes:

eZ Identifier:
- Fixed: Aqcuiring a unique ID is now done the first time an object is created
  and not only when it is created.
- Fixed: Acquiring a new unique ID is not present in previous versions.
- Fixed: Sort key were not in lowercase.

eZ Url:
- Fixed: serialising/unserialising, if attribute is empty.
- Fixed: data_text was not serialised/unserialised.

eZ BinaryFile:
- Changed: Updated mime handling with files.

eZ Media:
- Changed: Updated mime handling with files.

*Bugfixes:
- Fixed bug of updating priority does not work if parent node is not main node.
  http://ez.no/community/bug_reports/set_order_priority_in_other_location_no_main_location
- Fixed bug in ezkeyword datatype which will store duplicated keyword if keyword contains apostrophe (').
- Fixed bug of inconsistency between template and fetchalias.ini.
  http://ez.no/community/bug_reports/inconsistency_between_template_and_fetchalias_ini
- Fixed incorrect break statement
  (Merged from trunk/3.5rc1 rev. 9617)
- Fixed bug: viewing the object with attibute of  datatype which is not present causes fatal error
  http://ez.no/community/bug_reports/crash_with_object_when_datatype_is_not_present
- Fixed problem with the decimal separator and compiled templates
  http://ez.no/community/bug_reports/compiled_template_and_decimalsymbol_problem_parse_error
- Fixed bug with non-mandatory user datatype, entered mail but not username
  http://ez.no/community/bug_reports/ezuser_strange_behavior
- Fixed bug with translation extension when using eng-GB
  http://ez.no/community/bug_reports/extension_translation_with_eng_gb_has_limitation_that_other_don_t_have
- Fixed wrong function call 'attributes' vs 'attribute' in contentclass
  package handler.
- Fixed usage of wrong defines in 'set' template operator.
- Fixed bug some template typo errors.
  http://ez.no/community/bug_reports/template_typo_errors
- Fixed bug of duplicated keyword stored.
  http://ez.no/community/bug_reports/critical_keywords_will_be_duplicated_at_each_publishing_process
- Fixed bug of fatal error occurs if class id or parent node id is not exist when creating new object.
  http://ez.no/community/bug_reports/kernel_content_action_php_fatal_error_at_wrong_classid
- Fixed bug of potential fatal error may occur in ezcontentcachemanager.php.
  http://ez.no/community/bug_reports/3_5_deleting_objects_fatal_error_in_kernel_classes_ezcontentcachemanager_php
- Fixed bug of fatal error may occur in ezrole.php.
  http://ez.no/community/bug_reports/3_5_deleting_objects_fatal_error_in_kernel_classes_ezrole_php
- Fixed bug with triing load of empty string translation file multiple times.
  (Merged from stable/3.3 rev. 9762)
  http://ez.no/community/bug_reports/nno_no_translation_is_empty
- Fixed bug of unserializing ezcontentobjecttreenode get an extra attribute.
  http://ez.no/community/bug_reports/ezcontentobjecttreenode_unserialize_passes_unneeded_array_key
- Fixed bug in eZIniSettingType: removing setting of type array causes removing
  whole section.
  (Manually merged from stable/3.3 rev. 9785)
  http://ez.no/community/bug_reports/deleting_the_meta_data_array_makes_site_unreachable_default_siteaccess_is_undefined
- Fixed bug of fatal error caused by undeleted workflow processes when associated workflow event is deleted.
  http://ez.no/community/bug_reports/fatal_error_in_cronjob_after_editing_workflow
- Fixed bug with viewing discount rules with removed products.
  http://ez.no/community/bug_reports/deleted_product_and_discount_list
- Fixed bug of cronjob linkcheck not work properly with internal link. [linkCheckSettings] is added to cronjob.ini where
  you should specify site URLs.
  http://ez.no/community/bug_reports/cronjob_linkcheck_has_outdated_code_when_checking_relative_urls
- Fixed bug with non-static parameters to the i18n operator with use of the
  template compiler.
  (Manually merged from trunk/3.5 rev. 10004)
  http://ez.no/community/bug_reports/3_5_i18n_operator_doesn_t_take_variables_as_input_anymore
- Fixed missing error checking of non-existing nodes when fetching subtrees.
  http://ez.no/community/bug_reports/3_5_fatal_error_ezcontentobjecttreenode_php
  (Merged from stable/3.3 (3.3-7) rev. 10010)
- Fixed missing error checking of non-existing nodes when fetching subtree counts.
- Added a work around for a bug in IE.
  http://ez.no/community/bug_reports/pdf_on_the_fly_issue_with_ie_wrong_header
- Fixed call-time pass-by-reference warning.
  http://ez.no/community/bug_reports/call_time_pass_by_reference_in_ezsmtptransport_php
  (Merged from stable/3.3, rev. 10052)
- Fixed bug with generating package names with non-standard-latin characters.
  http://ez.no/community/bug_reports/3_5_package_create_no_utf_8_package_name
  (Manually merged from stable/3.4, rev. 10038)
- Added some more clean-up code for when users are deleted.
  Part of: http://ez.no/community/bug_reports/3_5_deleting_objects_dirty_tables_after_deleting_process
  (Merged from stable/3.4, rev. 10082)
- Fixed PDF generation bug.
  http://ez.no/community/bug_reports/fatal_error_in_pdf_generation
- Fixed bug of no search index generated for datatype 'datetime'.
- Fixed bug: "target" object parameter was sometimes unset in ezxhtmlxmloutput.php.
  (Merged from stable/3.3, rev. 10115)
  http://ez.no/community/bug_reports/xhtml_output_and_attribute_target
- Fixed bug: ezurl-operator fails on anchors (#) when TemplateCompile=enabled
  http://ez.no/community/bug_reports/ezurl_operator_fails_on_anchors_when_templatecompile_enabled
- Fixed bug: Set preference does return to different location.
  (Merged from stable/3.3 rev. 10136)
  http://ez.no/community/bug_reports/set_preference_does_return_to_different_location
- Fixed bug: Call to undefined function: missingvariable()
  (Merged from stable/3.3 rev. 10137)
  http://ez.no/community/bug_reports/call_to_undefined_function_missingvariable
- Fixed some PHP warnings in the template system's sequence function
- Added extra check to see if there are any keywords at all when cleaning them up
  http://ez.no/community/bug_reports/3_5_removing_nodes_objects_manually_fatal_errors
  (Merged from stable/3.3, rev. 10150)
- Added checks to object removals for cases where the object already was deleted
  http://ez.no/community/bug_reports/3_5_removing_nodes_objects_manually_fatal_errors
  (Merged from stable/3.3, rev. 10153)
- Fixed bug in ezsoap: Can't use arrays as soap function parameters
- Fixed bug in standard core.css: Missing styles for object-left and object-right
- Fixed bug with setting template namespaces and toolboxes
  http://ez.no/community/bug_reports/toolbar_function_ignores_namespaces_in_template_variable_management
  (Merged from trunk/3.5, rev. 10191)
- Fixed bug with ezstring and max-length validation
  http://ez.no/community/bug_reports/3_5_max_text_input_restriction_don_t_work_with_utf_8
  (Merged from trunk/3.5, rev. 10196)
- Fixed bug with unchecked nodeID
  http://ez.no/community/bug_reports/node_not_set_and_fatal_error
  (Merged from trunk/3.5, rev. 10218)
- Fixed bug with indexing of attributes and translations
  http://ez.no/community/bug_reports/search_doubled_indexed_words_in_ezsearch_object_word_link
  (Merged from trunk/3.5, rev. 10229)
- Added smarter script initialization errors handling.
- Fixed bug: When importing a 3.3 content class package, two classes are created instead of one.
  http://ez.no/community/bug_reports/import_package_with_one_content_class_results_in_two_content_classes
- Fixed a PHP warning in packagehandlers/contentclass/ezcontentclasspackagehandler.php.
- Fixed bug with missing class_identifier override key.
  http://ez.no/community/bug_reports/class_identifier_and_override_problems
  (Manually merged from stable/3.3 (3.3-7) rev. 10257.
- Added missing class and section override keys for the
  content_version_view_gui template function.
  (Manually merged from stable/3.3 (3.3-7) rev. 10257.
- Fixed bug Workflow results are ignored in content/edit.php.
  http://ez.no/community/bug_reports/workflow_results_are_ignored_in_content_edit_php
- Fixed bug in archive handler in doWrite() method, the length parameter was
  not checked for false and would in some cases not write any data at all.
  (Merged from stable/3.3 (3.3-7) rev. 10272)
- Fixed bug: unable to play .mov demo file, missing .asf demo file
  http://ez.no/community/bug_reports/asf_demo_not_working_missing_file
- Removed setting path in content/versionview, merged from stable/3.3 rev. 10284.
  http://ez.no/community/bug_reports/crash_when_using_versionview
- eZIdentifier datatype now correctly sets the sort_key_string value
  (Merged from stable/3.3 rev. 10311)
- Fixed doxygen comment in ezrole.
  http://ez.no/community/bug_reports/ezrole_createtemporaryversion_claims_to_be_static_but_isn_t
- Fixed bug: Deleting nodes -> role assignment isn't deleted.
  http://ez.no/community/bug_reports/3_5rc2_deleting_nodes_role_assignment_isn_t_deleted
- Fixed bug with exporting packages
  http://ez.no/community/bug_reports/3_5_0rc2_package_file_size_is_0b
  (Merged from stable/3.5, rev. 10355)
- Fixed security problem in tip a friend module, it is not possible to send more then 
  X emails in Y hours.
- Fixed bug: Override template content/browse.tpl is not possible when match like section or class_identifier.
  http://ez.no/community/bugs/ovveride_template_browse_and_section_id
  (Manually merged from trunk/3.5, rev. 10411)
- Fixed bug: errors when usign 'attribute' template-operator.
  http://ez.no/community/bugs/object_ezcontentclassattribute_problems
- Fixed bug  recursive object inclusion in xml field.
  http://ez.no/bugs/view/5989
  (Merged from trunk rev. 10444).
- Fixed bug 6010: product statistics SQL crash.
- Fixed bug: links in xmltext fields are not exported/imported. 
  http://ez.no/community/bug_reports/3_5_package_export_xml_field_links_aren_t_exportet_importet
  (Manually merged from trunk revisions 10347 and 10379)
- Fixed bug #5325 (problem when importing a class with the same class identifier as an existing class has).
  (Partially merged from trunk rev. 10289)
- Fixed bugs happening when exporting object along with all its versions and then importing that object:
  * Version status was set only for current version when importing.
  * Lots of fatal errors were shown when importing because of missing object name in all the exported translations.
  * Object name is now exported/imported in all object versions and translations.
  http://ez.no/bugs/view/5848
  (Merged from trunk 10349, stable/3.5 rev. 10459)
- Fixed bug #4299: No Translations update when changing an Object Relation Attribute with Disabled Translation.
  http://ez.no/community/bugs/no_translations_update_when_changing_an_object_relation_attribute_with_disabled_translation
  (Merged from stable/3.3 rev. 10470)
- Fixed bug #5943: When changing the list of objects related to object A, translation of A were not updated.
  (Merged from stable/3.3 rev. 10477)
- Fixed bug:  Partially broken tipafriend functionality.
  http://ez.no/bugs/view/5965
- Fixed bug #6024: Debug: popup - wrong path to debug.html file.
  (Merged from stable/3.3 rev. 10486)
- Fixed bug: #5534 time attribute can't be left empty.
  http://www.ez.no/community/bugs/time_attribute_can_t_be_left_empty
- Fixed bug: #4064 Bug eZTime problem and inconsistency
  http://ez.no/community/bugs/eztime_problem_and_inconsistency
- Fixed bug: #4664 Bug Datatype eZtime stores and returns incorrect values
  http://ez.no/community/bugs/datatype_eztime_stores_and_returns_incorrect_values
- Fixed bug #4553: Problems with \0 characters for PostGreSQL and ezXML::createTextNode.
  http://ez.no/bugs/view/4553
- Fixed bug #6020: Smart Viewcache enabled by default
  http://ez.no/bugs/view/6020
- Fixed bug #5849: Paginated pages only print out first page instead of page being viewed.
  $site.original_uri attribute added.
  (Manually merged from trunk/3.6 rev. 10497)
- Fixed bug #6057: calendar toolbox with only 1. and last week of Jan 2005
- Fixed bug using template caching, and not viewcache. Template cache is now cleared properly.
  Example : {cache-block} would not expire properly earlier when content cache was disabled. 
- Fixed: Adding eZ Identifier datatype does not generate ID for existing objects (Bug #6109)
- Fixed bug #6107: Variables loosing content in deep nesting template constructs.
- Fixed: Extensions could not override template.ini entries. (Bug #6129)
- Fixed: User setting DefaultSectionID in site.ini (Bug #6039)
  (Merged from stable/3.3 (3.3-7) rev. 10631)
- Fixed bug: Feed of RSS export was not cachied properly
  (Merged from stable/3.3 (3.3-7) rev. 10675)
- Fixed bug #6094: eZPersistentObject uses a locale dependent decimal separator
  when generating SQL.
- Fixed bug #6096: URL management, possible cache problem.
  (Merged from stable/3.5 (3.5.1) rev. 10698)
- Fixed bug #4033: <literal> tag removes heading whitespace.
  (Merged from stable/3.3 (3.3-7) rev. 10697)
- Fixed bug #6040: RSS Import -- URLS are stored incorrectly into ezstring attributes.
  (Merged from stable/3.3 (3.3-7) rev. 10709)
- Fixed bug #6151: Buggy node fetching when using classfilter with nonexistent
  class identifier.
- Fixed bug #6166: forgot password entries are not removed once password is 
  regenerated.
  (Merged from stable/3.5 rev. 10719)
- Fixed bug #6091: Template operators and locate settings problem.
  (Merged from stable/3.3 (3.3-7) rev. 10720)
- Fixed bug #6169: SQL errors and general warnings when create new RSS export.
  ( Manually merged from trunk/3.6 rev. 10730 )
- Fixed bug #5967: Undefined variable warnings in compiled templates.
- Fixed bug #6034: eZMYSQLDB::query() unproper error handling
  (Merged from stable/3.3 (3.3-7) rev. 10746)
- Fixed bug #6032: sql error after deleting object.
- Fixed bug #6095: File upload fails.
- Fixed bug #4411: Modules does not work after creating node named like module.
  (Merged from stable/3.3 (3.3-7) rev. 10767, 10768)
- Fixed bug #6179: Bug Symlinked entries in the extension dir will not been shown.
- Fixed bug #5983: User id is not stored in workflow processes.
  (Merged from stable/3.3 (3.3-7) rev. 10783)
- Fixed bug #6165: A Problem with Paypal Extension in Ez 3.5.0.
  (Merged from stable/3.5 (3.5.1) rev.10786, also in stable/3.3 (3.3-7) rev.10788)
- Fixed bug: SQL error in some DBMSs when publishing a large article.
  (Merged from stable/3.3 (3.3-7) rev. 10801)
- Fixed bug #5969: Warning when redirecting
  (Merged from stable/3.5 (3.5.0) rev. 10400)
- Fixed bug #5959:  Versionview in trash - PostgreSQL
  (Merged from stable/3.5 (3.5.0) rev. 10404)
- Fixed: Creation of an unneeded workflow process parameter led to multiple
  workflow processes.
  (Merged from stable/3.3 (3.3-7) rev. 10819)
- Fixed bug #6185: Headers are not correctly rendered for XML-fields
- Fixed bug #6204: lib/compat.php missing by client code.
- Fixed bug: Registering new user while being logged in causes troubles for the
  currently logged in user.
  (Merged from release/3.3-7 (3.3-7) rev. 10868)
- Fixed: SQL errors when trying to store empty strings into
  integer fields in PostgreSQL.
- Fixed bug #6217: Wrong package version.
  (Manually merged from release/3.3-7 (3.3-7) rev. 10918)

*Library:

eZCLI:
- Made sure all errors, warnings and notices are sent to stderr.

eZDBSchema:
- Made sure the tables, indexes and fields are sorted after their names.
- Length field are now stored as integer instead of numeric strings.
- Fixed bug in PostgreSQL handler when generating SQL for dropping primary
  index.
- Fixed bug in MySQL handler when generating SQL for adding indexes.

eZTemplate:
- Fixed bug in template compiler when assigning the results of an expression to
  a PHP variable and the expression resulted in an object proxy (e..g section
  iterator)

eZFileHandler:
- Made sure copy() and move() methods check if source and destination points
  to the same file, if so it just returns true.

eZTarArchiveHandler:
- Made sure directories have the ending slash when storing in tar file.
- Made sure tar files are padded to 20 blocks (of 512 bytes) containing
  zero filled blocks.

eZHttpFile:
- Changed: Added method to allow datatypes to set mime type.

*Design:
- Removed admin.css from pagelayout.tpl and redirect.tpl in standard design.
  Merged from stable/3.3 rev. 10194

eZDateTime:
- Fixed bug with missing array in function setHMS().

eZMail:
- Fixed bug with extractEmail().
